#include "CCDControl.h"

#include "radioGroup.h"
#include "runtime.h"
#include "FISS.h"
#include <utility.h>  
#include "CCD.h"
#include "Atmcd32d.h"
#include <analysis.h>
#include <ansi_c.h>
#include "scanner.h"
#include "Thread.h" 


extern int 	temp_thread, temp_thread_id;  
extern long 	nCameraHandle1;		//camera handle1
extern long 	nCameraHandle2;		//camera handle2

int TempSet(int Onoff1, int Onoff2, int Temp1, int Temp2){
	//camera1
	unsigned int errorValue1, errorValue2; 
	int OffTemp=5;
	temp_thread=1;
	

	
		if(Onoff1){
			SetCurrentCamera(nCameraHandle1); 
			SetTemperature(Temp1);  
			errorValue1=CoolerON(); 
		}
		else
		{
			SetCurrentCamera(nCameraHandle1);
			SetTemperature(OffTemp);
			errorValue1=CoolerON();
		}
			
			
		if(Onoff2){
			SetCurrentCamera(nCameraHandle2);
			SetTemperature(Temp2); 
			errorValue2=CoolerON(); 
		}
		else
		{
			SetCurrentCamera(nCameraHandle2); 
			SetTemperature(OffTemp);
			errorValue2=CoolerON();
		}
		
		
		if(errorValue1!=DRV_SUCCESS || errorValue2!=DRV_SUCCESS)
		{
			temp_thread=0; 
			return 0;
		}

		if(Onoff1||Onoff2)
		{
			CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setTempThread, NULL, &temp_thread_id);
			CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
			CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id);				
		}
		return 1;	
}


int CameraQuitCooling(void)
{
	int current_ccd_temp1, current_ccd_temp2;
	unsigned int iCoolerStatus1, iCoolerStatus2;
	
	TempSet(1,1,0,0);
	while(1)
	{
		SetCurrentCamera(nCameraHandle1);
		iCoolerStatus1=GetTemperature(&current_ccd_temp1);
		SetCurrentCamera(nCameraHandle2);
		iCoolerStatus2=GetTemperature(&current_ccd_temp2);
		
		if((iCoolerStatus1==DRV_TEMP_STABILIZED) && (iCoolerStatus2==DRV_TEMP_STABILIZED)	)
		{
			CoolerOFF();
			SetCurrentCamera(nCameraHandle1);
			CoolerOFF();
			return 1; 
		}
	}
}
